//+------------------------------------------------------------------+
//|                                         Support&ResistanceEA.mq4 |
//|                                                           darren |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "darren"
#property link      "http://www.metaquotes.net"

//---- input parameters
extern int       TakeProfit=10;
extern int       Lots=1;
extern int       StopLoss=15;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+


int CountOrders(string _symbol, int order_type)
{
   int counter=0;
   for(int i=OrdersTotal()-1; i>=0; i--)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(Symbol()!=_symbol)
         continue; 
      if(OrderType()==order_type)
         counter++;
   }
   return(counter);
}



double Resistance [];
double R1[];
double Support;
double S1
int i;




int start()
  {
//----
    // finding support and resistance
   i=Bars;
 While(i>=0)
   {  
    R1 = iFractals(NULL,0, MODE_UPPER,i);
      if (R1>0)
        Resistance[i]=High[i];
      else 
        Resistance[i]=Resistance[i+1];
     
    S1 = iFractals(NULL,0, MODE_LOWER,i);   
      if (S1>0);
        Support[i]=Low[i];
      else
        Support[i]= support[i+1];
        
      i--;    
   }
  return(0);
}  

   // using values of the two previous bars; for actual and previous Bars
   // change last argumento to corresponding 0 and 1 (instead 1 and 2). 
   double k0 = iCustom(Symbol(), PERIOD_M5,"Stochastic",0,0);
   double k1 = iCustom(Symbol(), PERIOD_M5,"Stochastic",0,1);
   double k2 = iCustom(Symbol(), PERIOD_M5,"Stochastic",0,2);
   
   double d0 = iCustom(Symbol(), PERIOD_M5,"Stochastic",1,0);
   double d1 = iCustom(Symbol(), PERIOD_M5,"Stochastic",1,1);
   double d2 = iCustom(Symbol(), PERIOD_M5,"Stochastic",1,2); 
   
   
   
   
   int digits = MarketInfo(Symbol(),MODE_DIGITS);
   //BUY SIGNAL   
   
    if(k2<d2 && k1> d1)
      // if(CurrentPrice>support && higher than previous bar)        
      {
         if( CountOrders(Symbol(), OP_BUY)==0)
            OrderSend(Symbol(),OP_BUY,0.1,Ask,3,0,0,Ask+TakeProfit*Point,StopLoss",0,0,White);       
      }      
   //SELL SIGNAL      
   
    if(k2>d2 && k1< d1)
     // if(CurrentPrice<Resistance && lower than previous bar)      
      {
         if( CountOrders(Symbol(), OP_SELL)==0)
            OrderSend(Symbol(),OP_SELL,0.1,Bid,3,0,0,Ask+TakeProfit*Point,StopLoss",0,0,Red);       
      }    
   
  
//----
   return(0);
  }
//+------------------------------------------------------------------+
/* The system for this EA is finding the support and Resistance,
  when stochastic cross up,the current price is higher than support and
  once break the previous bar high,buy.Take profit 10pips,stop loss 15pips
  sell signal is when stochastic cross down,current price is less than resistance,
  and break previous bar low,sell.Take profit 10pips,stop loss 15pips. */